#line 1 "C:/Users/katarina.perendic/Desktop/ClockGen2_demo/c/ClockGen2_demo.c"
#line 1 "c:/users/katarina.perendic/desktop/clockgen2_demo/c/demo_types.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/katarina.perendic/desktop/clockgen2_demo/c/demo_config.h"
#line 1 "c:/users/katarina.perendic/desktop/clockgen2_demo/c/demo_types.h"
#line 3 "c:/users/katarina.perendic/desktop/clockgen2_demo/c/demo_config.h"
const uint32_t _CLOCKGEN2_I2C_CFG[ 1 ] =
{
 100000
};
const uint32_t _TOUCHKEY4_I2C_CFG[ 1 ] =
{
 100000
};
#line 4 "C:/Users/katarina.perendic/Desktop/ClockGen2_demo/c/ClockGen2_demo.c"
uint8_t sensorResults[ 3 ];
uint8_t cnt;

void systemInit()
{
 mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_INT_PIN, _GPIO_INPUT );
 mikrobus_i2cInit( _MIKROBUS1, &_TOUCHKEY4_I2C_CFG[0] );
 mikrobus_logInit( _MIKROBUS2, 9600 );

 mikrobus_gpioInit( _MIKROBUS2, _MIKROBUS_PWM_PIN, _GPIO_OUTPUT );
 mikrobus_gpioInit( _MIKROBUS2, _MIKROBUS_RST_PIN, _GPIO_OUTPUT );
 mikrobus_gpioInit( _MIKROBUS2, _MIKROBUS_CS_PIN, _GPIO_OUTPUT );
 mikrobus_i2cInit( _MIKROBUS2, &_CLOCKGEN2_I2C_CFG[0] );
 Delay_ms( 100 );
}

void applicationInit()
{
 touchkey4_i2cDriverInit( ( const uint8_t* )&_MIKROBUS1_GPIO, ( const uint8_t* )&_MIKROBUS1_I2C, 0x28 );
 clockgen2_i2cDriverInit( ( const uint8_t* )&_MIKROBUS2_GPIO, ( const uint8_t* )&_MIKROBUS2_I2C, CLOCKGEN2_ADDR );
 mikrobus_logWrite( "TouchKey 4 is initialized", _LOG_LINE );
 Delay_ms( 200 );

 touchkey4_writeReg( _TOUCHKEY4_CONFIG2_REG, _TOUCHKEY4_AN_CALIB_RETRY | _TOUCHKEY4_DETECT_RELEASE_EN );
 touchkey4_writeReg( _TOUCHKEY4_REPEAT_RATE_EN_REG, _TOUCHKEY4_INPUT2_REPEAT_RATE_EN );
 touchkey4_writeReg( _TOUCHKEY4_CONFIG_REG, _TOUCHKEY4_AN_NOISE_FILTER_EN | _TOUCHKEY4_DIG_NOISE_THRESHOLD_DIS );
 touchkey4_writeReg( _TOUCHKEY4_STANDBY_THRESHOLD_REG, 0x40 );
 touchkey4_writeReg( _TOUCHKEY4_STANDBY_SENSITIVITY_REG, _TOUCHKEY4_STBY_SENSE_MULTIPLIER_64X );
 touchkey4_writeReg( _TOUCHKEY4_STANDBY_CONFIG_REG, _TOUCHKEY4_8_SAMPLES | _TOUCHKEY4_SAMPLE_TIME_1280MICROSEC | _TOUCHKEY4_CYCLE_TIME_70MILISEC );
 touchkey4_writeReg( _TOUCHKEY4_AVRG_AND_SAMPL_CONFIG_REG, _TOUCHKEY4_8_SAMPLES | _TOUCHKEY4_SAMPLE_TIME_1280MICROSEC | _TOUCHKEY4_CYCLE_TIME_70MILISEC );
 touchkey4_writeReg( _TOUCHKEY4_SENS_IN_CONFIG2_REG, _TOUCHKEY4_PRESS_AND_HOLD_EVENT_AFTER_280MILISEC );
 touchkey4_writeReg( _TOUCHKEY4_SENS_IN_CONFIG_REG, _TOUCHKEY4_5600MILISEC_BEFORE_RECALIB | _TOUCHKEY4_INTERR_REPEAT_RATE_175MILISEC );
 touchkey4_writeReg( _TOUCHKEY4_SENSITIVITY_CON_REG, _TOUCHKEY4_SENSITIVITY_MULTIPLIER_32X | _TOUCHKEY4_DATA_SCALING_FACTOR_256X );
 touchkey4_setComboMode( _TOUCHKEY4_GAIN_1, _TOUCHKEY4_COMBO_SENS_IN_ACT_EN, _TOUCHKEY4_COMBO_SENS_IN_BOTH_MODES_EN, _TOUCHKEY4_COMBO_SENS_IN_STBY_EN );
 Delay_ms( 200 );
}

void applicationTask()
{
 touchkey4_detectTouch( &sensorResults[0] );
 for (cnt = 0; cnt < 3; cnt++)
 {
 if (sensorResults[ cnt ] == 1)
 {
 if (cnt == 0)
 {
 mikrobus_logWrite( "Input 1 is touched", _LOG_LINE );
 clockgen2_outputEnable(0);
 clockgen2_setPrescaler(5);
 clockgen2_outputEnable(1);
 }
 else if (cnt == 1)
 {
 mikrobus_logWrite( "Input 2 is touched", _LOG_LINE );
 clockgen2_outputEnable(0);
 clockgen2_setPrescaler(6);
 clockgen2_outputEnable(1);
 }
 else
 {
 mikrobus_logWrite( "Input 3 is touched", _LOG_LINE );
 clockgen2_outputEnable(0);
 clockgen2_setPrescaler(7);
 clockgen2_outputEnable(1);
 }
 }
 }
}

void main()
{
 systemInit();
 applicationInit();

 while (1)
 {
 applicationTask();
 }
}
